/*
rev.c
writes out a file, line by line, in reversed order of characters, on stdout;
like cat, but every line is reversed
unlike cat, it does not know about multiple files on input,
for that purpose, use cat first and pipe its output to rev

CopyLeft 2003 Alexandr Babic <sasa@plan9.cz>
cosmetic "improvements" by Peter A. Cejchan <cej@gli.cas.cz>
Mon Jul 21 07:24:15 EDT 2003

usage:
	rev [-option]  [file]
*/

#include<u.h>
#include<libc.h>
#include<bio.h>
#include<String.h>

void
usage(void)
{
	fprint(2, "rev -- print out lines in reversed order of chars\n");
	fprint(2, "usage:\n\trev [-option]  [file]\n");
	fprint(2, "options:\n\t-h\thelp\n\t-v\tversion info\n");
	exits("usage");
}


void
version(void)
{
	fprint(2, "  rev\n");
	fprint(2, "  version 0.03\n");
	fprint(2, "  Copy(L)eft 2003 Sasa Babic, Peter A. Cejchan\n");
	exits("help");
}


void
main(int argc, char *argv[])
{
	Biobuf bfile; /* buffer pro vstupni fajl */
	int c;        /* nacteny znak*/ 
	char *cha;    /* nacteny znak ale jako char* */
	int i;
	int j;
	int fd;       /* file descriptor otevreneho vstupniho fajlu */ 
	String *tnaruby; /* string pro vystupni text */

	ARGBEGIN
	{
		case 'v':
			version();
			break;
		case 'h':
		default:
			usage();
	}ARGEND

	switch(argc){
		case 0:
			fd = 0;
			break;
		case 1:
			fd= open(argv[0], OREAD);
			break;
		default:
			usage();
	}

	Binit(&bfile,fd,OREAD);

	tnaruby=s_new();
	s_reset(tnaruby);
	i=0;

	while((c=Bgetc(&bfile)) !=Beof)
	{
		cha=(char*)&c;
 
		if(c!=0xa) 
 		{
			s_append(tnaruby,cha);
			i++;
		}
		else
		{
			for(j=i-1;j>=0;j--) 
				print("%c",tnaruby->base[j]);
			print("\n");
			 s_reset(tnaruby);
				i=0;
		}
	}

	close(fd);
	exits(0);
}


